var qiao = {};
var host = "http://app.weimeigou.com/";
qiao.on = function(obj, event, func){
	$(document).off(event, obj).on(event, obj, func);
};
qiao.juicer = function(el, data, callback){
	if(el){
		var $tpl = $(el);
		$tpl.after(juicer($tpl.html(), data));
		if(callback) callback();
	}
};

qiao.h = {};
// page相关
qiao.h.normalStyle = {top:'45px',bottom:"50px"};
qiao.h.fullStyle = {top:'0px',bottom:'0px'};
qiao.h.centerStyle = {top:'45px',bottom:'50px'};
qiao.h.normalPage = function(id, options){
	var opt = $.extend({}, options, qiao.h.fullStyle);
	return qiao.h.page(id, {styles : opt});
};
qiao.h.centerPage = function(id, options){
	var opt = $.extend({}, options, qiao.h.normalStyle);
	return qiao.h.page(id, {styles : opt});
};
qiao.h.page = function(id, options){
	var url = id + '.html';

	options.id = id;
	options.url = url;
	return options;
};
qiao.h.indexPage = function(){
	return plus.webview.getWebviewById(plus.runtime.appid);
};
qiao.h.currentPage = function(){
	return plus.webview.currentWebview();
};
qiao.h.getPage = function(id){
	return id ? plus.webview.getWebviewById(id) : null;
};
qiao.h.show = function(id, ani, time, func){
	if(id) plus.webview.show(id, ani, time, func);
};
qiao.h.hide = function(id, ani, time){
	if(id) plus.webview.hide(id, ani, time);
};
qiao.h.fire = function(id, name, values){
	mui.fire(qiao.h.getPage(id), name, values);
};

qiao.h.open = function(id,ani,time,func){
	if(id) plus.webview.open(id, ani, time, func);
}

// 以下为UI封装------------------------------------------------------------------------------
// qiao.h.tip
qiao.h.tip = function(msg, options){
	plus.nativeUI.toast(msg,options);
};

// qiao.h.waiting
qiao.h.waiting = function(titile, options){
	plus.nativeUI.showWaiting(titile, options);
};
qiao.h.closeWaiting = function(){
	plus.nativeUI.closeWaiting();
};

// popover
qiao.h.pop = function(){
	mui('.mui-popover').popover('toggle');
};

// actionsheet
qiao.h.sheet = function(title, btns,func){
	if(title && btns && btns.length > 0){
		var btnArray = [];
		for(var i=0; i<btns.length; i++){
			btnArray.push({title:btns[i]});
		}

		plus.nativeUI.actionSheet({
			title : title,
			cancel : '取消',
			buttons : btnArray
		}, function(e){
			if(func) func(e);
		});
	}
};

// 提示框相关
qiao.h.modaloptions = {
	title 	: 'title',
	abtn	: '确定',
	cbtn	: ['确定','取消'],
	content	: 'content'
};
qiao.h.alert = function(options, ok){
	var opt = $.extend({}, qiao.h.modaloptions);

	opt.title = '提示';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}

	plus.nativeUI.alert(opt.content, function(e){
		if(ok) ok();
	}, opt.title, opt.abtn);
};
qiao.h.confirm = function(options, ok, cancel){
	var opt = $.extend({}, qiao.h.modaloptions);

	opt.title = '确认操作';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}

	plus.nativeUI.confirm(opt.content, function(e){
		var i = e.index;
		if(i == 0 && ok) ok();
		if(i == 1 && cancel) cancel();
	}, opt.title, opt.cbtn);
};
qiao.h.prompt = function(options, ok, cancel){
	var opt = $.extend({}, qiao.h.modaloptions);

	opt.title = '输入内容';
	if(typeof options == 'string'){
		opt.content = options;
	}else{
		$.extend(opt, options);
	}

	plus.nativeUI.prompt(opt.content, function(e){
		var i = e.index;
		if(i == 0 && ok) ok(e.value);
		if(i == 1 && cancel) cancel(e.value);
	}, opt.title, opt.content, opt.cbtn);
};

// 以下为插件封装------------------------------------------------------------------------------
// 本地存储相关
qiao.h.length = function(){
	return plus.storage.getLength();
};
qiao.h.key = function(i){
	return plus.storage.key(i);
};
qiao.h.getItem = function(key){
	if(key){
		for(var i=0; i<qiao.h.length(); i++) {
			if(key == plus.storage.key(i)){
				return plus.storage.getItem(key);
			}
		};
	}
	return null;
};
qiao.h.insertItem = function(key, value){
	plus.storage.setItem(key, value);
};
qiao.h.delItem = function(key){
	plus.storage.removeItem(key);
};
qiao.h.clear = function(){
	plus.storage.clear();
};

//ajax
qiao.h.ajaxGet = function(url, arg, onSuccess){
	mui.ajax(host+url,{
		data:arg,
		dataType:'json',//服务器返回json格式数据
		type:'get',//HTTP请求类型
		timeout:10000,//超时时间设置为10秒；
		headers:{'Content-Type':'application/json'},
		success:function(data){
			onSuccess(data);
		},
		error:function(xhr,type,errorThrown){
		}
	});
}

qiao.h.ajaxPost = function(url, arg, onSuccess){
	var originUser = plus.storage.getItem("user");
	var user = JSON.parse(originUser);

	if(!originUser || user.refresh_token_expires==null || user.refresh_token_expires<=Date.parse(new Date())/1000){
		qiao.h.goLogin();
		return;
	};

	var actionData = $.extend({userid:user.userid, token:user.token}, arg);
	if(user.token_expires<=Date.parse(new Date())/1000){
		var data = {userid:user.userid, refresh_token:user.refresh_token};
		plus.nativeUI.showWaiting();
		mui.ajax(host+'index.php/Api/Login/refresh_token',{
			data:data,
			dataType:'json',//服务器返回json格式数据
			type:'post',//HTTP请求类型
			timeout:10000,//超时时间设置为10秒；
			success:function(data){
				if(data.statuscode==200){
					user.token = data.data;
					user.token_expires = Date.parse(new Date())/1000+21600;
					plus.storage.setItem("user",JSON.stringify(user));
				}else{
					qiao.h.goLogin();
					return;
				}
				actionData = $.extend({userid:user.userid, token:user.token}, arg);
				qiao.h.ajaxAction(url, actionData, onSuccess);
				plus.nativeUI.closeWaiting();
			},
			error:function(xhr,type,errorThrown){
				qiao.h.goLogin();
			}
		});
	}else{
		qiao.h.ajaxAction(url, actionData, onSuccess);
	}
}
qiao.h.goLogin = function(){
	mui.openWindow({
		url:'/views/login.html',
		id:'/views/login.html',
	});
}

qiao.h.ajaxAction = function(url, data, onSuccess){
	var originUser = plus.storage.getItem("user");
	if(originUser){
		var user = JSON.parse(originUser);
		data = $.extend({userid:user.userid, token:user.token}, data)
	}
	mui.ajax(host+url,{
		data:data,
		dataType:'json',//服务器返回json格式数据
		type:'post',//HTTP请求类型
		timeout:10000,//超时时间设置为10秒；
		success:function(data){
			onSuccess(data);
		},
		error:function(xhr,type,errorThrown){
		}
	});
}
//判断登录
//打开分享页面
qiao.h.share = function(msgattr){

	var actionbuttons = [{title : "微信好友"}, {title : "朋友圈"}];
	var actionstyle   = {title : "请选择分享类型", cancel : "取消", buttons : actionbuttons};
	plus.nativeUI.actionSheet(actionstyle, function(e){
		if(e.index){qiao.h.shareNow(e.index, msgattr);}
	});

}

var shareWx = null;
qiao.h.shareNow = function(type, msgattr){
	plus.share.getServices(function(services){
		for(var k in services){
			if(services[k].id = 'weixin'){
				shareWx = services[k];
			}
		}
		if(shareWx == null){mui.toast('您没有安装微信'); return;}
		var msg = msgattr;
		if(type == 1){
			msg.extra = {scene:"WXSceneSession"}
		}else{
			msg.extra = {scene:"WXSceneTimeline"}
		}
		shareWx.send(msg, function(){

			mui.toast('分享成功');
		}, function(){
			mui.toast('您取消了分享');
		});
	}, function(){
		mui.toast('获取分享服务失败');
	});
}

qiao.h.judgeLogin = function(){}

// web sql
qiao.h.db = function(name, size){
	var db_name = name ? name : 'db_test';
	var db_size = size ? size : 2;

	return openDatabase(db_name, '1.0', 'db_test', db_size * 1024 * 1024);
};
qiao.h.update = function(db, sql){
	if(db &&sql){
		db.transaction(function(tx){tx.executeSql(sql);});
	}
};
qiao.h.query = function(db, sql, func){
	if(db && sql){
		db.transaction(function(tx){
			tx.executeSql(sql, [], function(tx, results) {
				func(results);
			}, null);
		});
	}
};

// 以下为功能封装------------------------------------------------------------------------------
// 退出
qiao.h.exit = function(){
	qiao.h.confirm('确定要退出吗？', function(){
		plus.runtime.quit();
	});
};
// 刷新
qiao.h.endDown = function(selector){
	var sel = selector ? selector : '#refreshContainer';
	mui(sel).pullRefresh().endPulldownToRefresh();
};

// init
var db = qiao.h.db();

